--- src/Makefile.orig
+++ src/Makefile
@@ -28,7 +28,8 @@
 
 PLATS= aix ansi bsd freebsd generic linux macosx mingw posix solaris
 
-LUA_A=	liblua.a
+LUA_A=	liblua-@BRANCH@.a
+LUA_DYLIB= liblua-@BRANCH@.dylib
 CORE_O=	lapi.o lcode.o lctype.o ldebug.o ldo.o ldump.o lfunc.o lgc.o llex.o \
 	lmem.o lobject.o lopcodes.o lparser.o lstate.o lstring.o ltable.o \
 	ltm.o lundump.o lvm.o lzio.o
@@ -43,8 +44,8 @@
 LUAC_O=	luac.o
 
 ALL_O= $(BASE_O) $(LUA_O) $(LUAC_O)
-ALL_T= $(LUA_A) $(LUA_T) $(LUAC_T)
-ALL_A= $(LUA_A)
+ALL_T= $(LUA_DYLIB) $(LUA_A) $(LUA_T) $(LUAC_T)
+ALL_A= $(LUA_DYLIB) $(LUA_A)
 
 # Targets start here.
 default: $(PLAT)
@@ -56,14 +57,20 @@
 a:	$(ALL_A)
 
 $(LUA_A): $(BASE_O)
+	@echo "Building static library"
 	$(AR) $@ $(BASE_O)
 	$(RANLIB) $@
 
+$(LUA_DYLIB): $(BASE_O)
+	@echo "Building dynamic library (dylib)"
+	$(CC) -o $@ $(MYLDFLAGS) -dynamiclib -install_name @PREFIX@/lib/lua-@BRANCH@/liblua-@BRANCH@.dylib \
+		-compatibility_version @BRANCH@ -current_version @VERSION@ $^
+
 $(LUA_T): $(LUA_O) $(LUA_A)
-	$(CC) -o $@ $(LDFLAGS) $(LUA_O) $(LUA_A) $(LIBS)
+	$(CC) -o $@ -L. $(MYLDFLAGS) $(MYCFLAGS) $(LIBS) -llua-@BRANCH@ lua.c
 
 $(LUAC_T): $(LUAC_O) $(LUA_A)
-	$(CC) -o $@ $(LDFLAGS) $(LUAC_O) $(LUA_A) $(LIBS)
+	$(CC) -o $@ $(MYLDFLAGS) $(LUAC_O) $(LUA_DYLIB) $(LIBS)
 
 clean:
 	$(RM) $(ALL_T) $(ALL_O)
@@ -106,7 +113,7 @@
 	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_LINUX" SYSLIBS="-Wl,-E -ldl -lreadline"
 
 macosx:
-	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_MACOSX" SYSLIBS="-lreadline" CC=cc
+	$(MAKE) $(ALL) SYSCFLAGS="-fno-common -DLUA_USE_MACOSX" SYSLIBS="-lreadline"
 
 mingw:
 	$(MAKE) "LUA_A=lua52.dll" "LUA_T=lua.exe" \
